/*
 * This Java source file was generated by the Gradle 'init' task.
 */
package ProcessJPG;

import exceptions.NoFileSpecified;
import exceptions.NotBase64JPG;
import exceptions.NotValidFilePath;
import org.apache.commons.codec.binary.Base64InputStream;
import org.apache.commons.codec.binary.Base64OutputStream;
import org.apache.commons.io.IOUtils;

import javax.imageio.IIOImage;
import javax.imageio.ImageIO;
import javax.imageio.ImageWriteParam;
import javax.imageio.ImageWriter;
import javax.imageio.stream.ImageOutputStream;
import java.awt.image.BufferedImage;
import java.io.*;
import java.util.Iterator;

public class ProcessJPG {
    private String imagePath;
    private File imageFile;
    private String imageFileName;
    private String imageFileExtension;
    private float imageHeight;
    private float imageWidth;
    private float compressionQuality;
    private boolean noPath; //@Test, only for testing

    private String getImagePath(){
        return this.imagePath;
    }
    private void setImagePath(String imagePath){
        this.imagePath = imagePath;
    }
    private String getImageFileName() { return this.imageFileName;}
    private void setImageFileName(String imageFileName) { this.imageFileName = imageFileName; }
    private String getImageFileExtension() { return this.imageFileExtension; }
    private void setImageFileExtension(String imageFileExtension) { this.imageFileExtension = imageFileExtension; }
    private float getImageHeight() {return this.imageHeight;}
    private void setImageHeight(float height) {this.imageHeight = height;}
    private float getImageWidth(){ return this.imageWidth; }
    private void setImageWidth(float width){ this.imageWidth = width;}
    private File getImageFile(){ return this.imageFile; }
    private void setImageFile(File imageFile) { this.imageFile = imageFile; }
    private float getCompressionQuality() {
        return compressionQuality;
    }
    private void setCompressionQuality(float compressionQuality) {
        this.compressionQuality = compressionQuality;
    }

    public boolean isNoPath() {
        return noPath;
    } //@Test, only for testing

    public void setNoPath(boolean noPath) {
        this.noPath = noPath;
    } //@Test, only for testing

    //Checks whether the file path is valid, returns false if not
    private boolean checkValidity(File imageFile){
        if (imageFile.isDirectory()){
            System.out.println("Found directory, but JPG file is needed");
            return false;
        }
        if (!imageFile.exists()){
            System.out.println("Such JPG does not exist");
            return false;
        }
        String[] splitName = this.getImagePath().split("[.]");
        if (!splitName[1].equals("jpg")){
            System.out.println("File is not jpg");
            return false;
        }
        return true;
    }

    //Exception, path have to be specified
    ProcessJPG() throws NoFileSpecified {
        throw new NoFileSpecified("JPG path is not specified for ".concat(this.getClass().getName()));
    }
    ProcessJPG(String imagePath) throws NotValidFilePath {
        File imageFile = new File(imagePath);
        setImagePath(imagePath);
        if ( !checkValidity(imageFile) ){
            throw new NotValidFilePath("File path is not valid, please refer to the above message for details");
        }

        setImagePath(imageFile.getPath());
        setImageFile(imageFile);
        String[] splitName = this.getImagePath().split("[.]");
        setImageFileName(splitName[0]);
        setImageFileExtension(splitName[1]);
        setNoPath(false);
    }

    public void reduceJPGDimensions(float compressionQuality) throws IOException, NotBase64JPG {
        setCompressionQuality(compressionQuality);
        File imageFile = getImageFile();
        File reducedImage = new File(getImageFileName().concat("_reduced.jpg"));

        //From File to InputStream
        InputStream inStream = new FileInputStream(imageFile);
        //Decode InputStream through Base64InputStream
        Base64InputStream base64InStream = new Base64InputStream(inStream);

        //Store Base64InputStream to byte[](..array)
        byte[] container = IOUtils.toByteArray(base64InStream);
        //From byte[] to ByteArrayInputStream
        InputStream containersInStream = new ByteArrayInputStream(container);

        OutputStream outStream = new FileOutputStream(reducedImage);
        Base64OutputStream base64OutStream = new Base64OutputStream(outStream);
        //Read ByteArrayInputStream into BufferedImage
        BufferedImage bufferedImage = ImageIO.read(containersInStream);
        if(bufferedImage == null){
            throw new NotBase64JPG("Specified image is not in BASE64");
        }
        setImageHeight(bufferedImage.getHeight());

        Iterator<ImageWriter> allWriters = ImageIO.getImageWritersByFormatName("jpg");
        if(!allWriters.hasNext()){
            throw new IllegalStateException("No writers for jpg format found");
        }
        ImageWriter imageWriter = (ImageWriter) allWriters.next();
        ImageOutputStream imgOutStream = ImageIO.createImageOutputStream(base64OutStream);
        imageWriter.setOutput(imgOutStream);

        ImageWriteParam param = imageWriter.getDefaultWriteParam();
        param.setCompressionMode(ImageWriteParam.MODE_EXPLICIT);
        param.setCompressionQuality(getCompressionQuality());

        imageWriter.write(null, new IIOImage(bufferedImage, null, null), param);

        inStream.close();
        base64InStream.close();
        containersInStream.close();
        outStream.close();
        base64OutStream.close();
        imgOutStream.close();
        imageWriter.dispose();
        setNoPath(true); //@Test, ie for testing
    }
}
